VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cCalendar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'********************************************************************
'*             22.04.2004  (Team HomeWork)              *
'*                   e-mail: sne_pro@mail.ru                        *
'********************************************************************

Private Declare Function CreateWindowEx Lib "user32.dll" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function InitCommonControlsEx Lib "comctl32.dll" (ByRef InitCommonCtl As INITCOMCTLSEX) As Long
Private Declare Function DestroyWindow Lib "user32.dll" (ByVal hWnd As Long) As Long
Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Private Type INITCOMCTLSEX
    dwSize          As Long
    dwICC           As Long
End Type
Private Type SYSTEMTIME
    wYear           As Integer
    wMonth          As Integer
    wDayOfWeek      As Integer
    wDay            As Integer
    wHour           As Integer
    wMinute         As Integer
    wSecond         As Integer
    wMilliseconds   As Integer
End Type
Private Type RECT
    Left            As Long
    Top             As Long
    Right           As Long
    Bottom          As Long
End Type

Public Enum gbHWMonthCalStyles
    MCS_DAYSTATE = &H1
    MCS_MULTISELECT = &H2
    MCS_NOTODAY = &H10
    MCS_NOTODAYCIRCLE = &H8
    MCS_WEEKNUMBERS = &H4
End Enum

Public Enum gbHWcMonthCal
    MCSC_BACKGROUND = 0
    MCSC_TEXT = 1
    MCSC_TITLEBK = 2
    MCSC_TITLETEXT = 3
    MCSC_MONTHBK = 4
    MCSC_TRAILINGTEXT = 5
End Enum

Private Const WS_CHILD              As Long = &H40000000
Private Const WS_TABSTOP            As Long = &H10000
Private Const WS_VISIBLE            As Long = &H10000000

Private Const MCM_FIRST             As Long = &H1000
Private Const MCN_FIRST             As Long = (-750)

Private Const MCN_SELCHANGE         As Long = (MCN_FIRST + 1)
Private Const MCN_SELECT            As Long = (MCN_FIRST + 4)

Private Const MCM_SETCOLOR          As Long = (MCM_FIRST + 10)
Private Const MCM_GETCOLOR          As Long = (MCM_FIRST + 11)
Private Const MCM_GETCURSEL         As Long = (MCM_FIRST + 1)
Private Const MCM_SETCURSEL         As Long = (MCM_FIRST + 2)
Private Const MCM_SETFIRSTDAYOFWEEK As Long = (MCM_FIRST + 15)
Private Const MCM_GETFIRSTDAYOFWEEK As Long = (MCM_FIRST + 16)
Private Const MCM_GETMAXSELCOUNT    As Long = (MCM_FIRST + 3)
Private Const MCM_SETMAXSELCOUNT    As Long = (MCM_FIRST + 4)
Private Const MCM_GETMAXTODAYWIDTH  As Long = (MCM_FIRST + 21)
Private Const MCM_GETMINREQRECT     As Long = (MCM_FIRST + 9)
Private Const MCM_GETMONTHDELTA     As Long = (MCM_FIRST + 19)
Private Const MCM_SETMONTHDELTA     As Long = (MCM_FIRST + 20)
Private Const MCM_GETRANGE          As Long = (MCM_FIRST + 17)
Private Const MCM_SETRANGE          As Long = (MCM_FIRST + 18)
Private Const MCM_GETSELRANGE       As Long = (MCM_FIRST + 5)
Private Const MCM_SETSELRANGE       As Long = (MCM_FIRST + 6)
Private Const MCM_GETTODAY          As Long = (MCM_FIRST + 13)
Private Const MCM_SETTODAY          As Long = (MCM_FIRST + 12)

Private Const vNull                 As Long = 0&

Public Event SelChange()
Public Event ChangeSelected()

Public hWnd As Long

Public Function Create(ByVal hParent As Long, _
                       ByVal dwFlags As gbHWMonthCalStyles, _
                       ByVal nLeft As Long, _
                       ByVal nTop As Long, _
                       ByVal nWidth As Long, _
                       ByVal nHeight As Long) As Boolean                                ' 
    Dim ictl As INITCOMCTLSEX, st(1) As SYSTEMTIME

    ictl.dwSize = Len(ictl)
    ictl.dwICC = &H100

    Call InitCommonControlsEx(ictl)
    hWnd = CreateWindowEx(0&, "SysMonthCal32", vbNullString, WS_CHILD Or WS_TABSTOP Or WS_VISIBLE Or dwFlags, nLeft, nTop, nWidth, nHeight, hParent, 0&, App.hInstance, 0&)

    Call mCalendar.SetCdrProc(Me)
    Create = Not (hWnd = vNull)
End Function

Public Sub Destroy()                                                                    ' 
    Call mCalendar.DelCdr(Me)
    Call DestroyWindow(hWnd)
End Sub

Public Property Get Color(ByVal iClr As Integer) As Long                                ' 
    Color = SendMessage(hWnd, MCM_GETCOLOR, iClr, ByVal vNull)
End Property

Public Property Let Color(ByVal iClr As Integer, ByVal newVal As Long)
    Call SendMessage(hWnd, MCM_SETCOLOR, iClr, ByVal newVal)
End Property

Public Property Get DayOfWeek() As Integer                                              '  
    Day = GetData.wDayOfWeek
End Property

Public Property Let DayOfWeek(ByVal newVal As Integer)
    Dim st As SYSTEMTIME

    st = GetData: st.wDayOfWeek = newVal
    Call SetData(st)
End Property

Public Property Get Day() As Integer                                                    '  
    Day = GetData.wDay
End Property

Public Property Let Day(ByVal newVal As Integer)
    Dim st As SYSTEMTIME

    st = GetData: st.wDay = newVal
    Call SetData(st)
End Property

Public Property Get Month() As Integer                                                  '  
    Month = GetData.wMonth
End Property

Public Property Let Month(ByVal newVal As Integer)
    Dim st As SYSTEMTIME

    st = GetData: st.wMonth = newVal
    Call SetData(st)
End Property

Public Property Get Year() As Integer                                                   '  
    Day = GetData.wYear
End Property

Public Property Let Year(ByVal newVal As Integer)
    Dim st As SYSTEMTIME

    st = GetData: st.wYear = newVal
    Call SetData(st)
End Property

Public Property Get FirstDayOfWeek() As Integer                                         '    
    FirstDayOfWeek = LoWord(SendMessage(hWnd, MCM_GETFIRSTDAYOFWEEK, vNull, ByVal vNull))
End Property

Public Property Let FirstDayOfWeek(ByVal newVal As Integer)
    Call SendMessage(hWnd, MCM_SETFIRSTDAYOFWEEK, vNull, ByVal newVal)
End Property

Public Property Get MaxSelCount() As Integer                                            ' . -   
    MaxSelCount = SendMessage(hWnd, MCM_GETMAXSELCOUNT, vNull, ByVal vNull)
End Property

Public Property Let MaxSelCount(ByVal newVal As Integer)
    Call SendMessage(hWnd, MCM_SETMAXSELCOUNT, newVal, ByVal vNull)
End Property

Public Property Get MaxTodayStrLen()                                                    ' .   ": --"
    MaxTodayStrLen = SendMessage(hWnd, MCM_GETMAXTODAYWIDTH, vNull, ByVal vNull)
End Property

Public Property Get MinWidth() As Long                                                  '   
    Dim rct As RECT

    Call SendMessage(hWnd, MCM_GETMINREQRECT, vNull, rct)
    MinWidth = rct.Right
End Property

Public Property Get MinHeight() As Long                                                 '  
    Dim rct As RECT

    Call SendMessage(hWnd, MCM_GETMINREQRECT, vNull, rct)
    MinHeight = rct.Bottom
End Property

Public Property Get MonthScrollStep() As Integer                                        '    ,   : "<"  ">"
    MonthScrollStep = SendMessage(hWnd, MCM_GETMONTHDELTA, vNull, vNull)
End Property

Public Property Let MonthScrollStep(ByVal intValue As Integer)
    Call SendMessage(hWnd, MCM_SETMONTHDELTA, intValue, ByVal vNull)
End Property

                                                                                        '   
Public Sub GetRange(Optional ByRef minYear As Integer, Optional ByRef minMonth As Integer, Optional ByRef minDay As Integer, _
                    Optional ByRef maxYear As Integer, Optional ByRef maxMonth As Integer, Optional ByRef maxDay As Integer)
    Dim syst(1) As SYSTEMTIME

    Call SendMessage(hWnd, MCM_GETRANGE, 1& Or 2&, syst(0))

    minYear = syst(0).wYear:    maxYear = syst(1).wYear
    minMonth = syst(0).wMonth:  maxMonth = syst(1).wMonth
    minDay = syst(0).wDay:      maxDay = syst(1).wDay
End Sub

                                                                                        '   
Public Sub SetRange(Optional ByVal minYear As Integer, Optional ByVal minMonth As Integer, Optional ByVal minDay As Integer, _
                    Optional ByVal maxYear As Integer, Optional ByVal maxMonth As Integer, Optional ByVal maxDay As Integer)

    Dim syst(1) As SYSTEMTIME

    Call SendMessage(hWnd, MCM_GETRANGE, 1& Or 2&, syst(0))

    syst(0).wYear = minYear:    syst(1).wYear = maxYear
    syst(0).wMonth = minMonth:  syst(1).wMonth = maxMonth
    syst(0).wDay = minDay:      syst(1).wDay = maxDay

    If syst(0).wYear = vNull Then syst(0).wYear = vbNull
    If syst(1).wYear = vNull Then syst(1).wYear = vbNull
    
    If syst(0).wMonth = vNull Then syst(0).wMonth = vbNull
    If syst(1).wMonth = vNull Then syst(1).wMonth = vbNull
    
    If syst(0).wDay = vNull Then syst(0).wDay = vbNull
    If syst(1).wDay = vNull Then syst(1).wDay = vbNull

    Call SendMessage(hWnd, MCM_SETRANGE, 1& Or 2&, syst(0))
End Sub

                                                                                        '   
Public Sub GetSelRange(Optional ByRef minYear As Integer, Optional ByRef minMonth As Integer, Optional ByRef minDay As Integer, _
                       Optional ByRef maxYear As Integer, Optional ByRef maxMonth As Integer, Optional ByRef maxDay As Integer)
    Dim syst(1) As SYSTEMTIME

    Call SendMessage(hWnd, MCM_GETSELRANGE, vNull, syst(0))

    minYear = syst(0).wYear:    maxYear = syst(1).wYear
    minMonth = syst(0).wMonth:  maxMonth = syst(1).wMonth
    minDay = syst(0).wDay:      maxDay = syst(1).wDay
End Sub

                                                                                        '   
Public Sub SetSelRange(Optional ByVal minYear As Integer, Optional ByVal minMonth As Integer, Optional ByVal minDay As Integer, _
                       Optional ByVal maxYear As Integer, Optional ByVal maxMonth As Integer, Optional ByVal maxDay As Integer)
    Dim syst(1) As SYSTEMTIME

    Call SendMessage(hWnd, MCM_GETSELRANGE, vNull, syst(0))

    syst(0).wYear = minYear:    syst(1).wYear = maxYear
    syst(0).wMonth = minMonth:  syst(1).wMonth = maxMonth
    syst(0).wDay = minDay:      syst(1).wDay = maxDay

    If syst(0).wYear = vNull Then syst(0).wYear = VBA.Year(Date)
    If syst(1).wYear = vNull Then syst(1).wYear = VBA.Year(Date)

    If syst(0).wMonth = vNull Then syst(0).wMonth = VBA.Month(Date)
    If syst(1).wMonth = vNull Then syst(1).wMonth = VBA.Month(Date)

    If syst(0).wDay = vNull Then syst(0).wDay = VBA.Day(Date)
    If syst(1).wDay = vNull Then syst(1).wDay = VBA.Day(Date)

    Call SendMessage(hWnd, MCM_SETSELRANGE, vNull, syst(0))
End Sub

                                                                                        '  " "
Public Function GetToday(Optional ByRef wYear As Integer, Optional ByRef wMonth As Integer, Optional ByRef wDay As Integer) As Boolean
    Dim st As SYSTEMTIME

    GetToday = SendMessage(hWnd, MCM_GETTODAY, vNull, st)

    wYear = st.wYear
    wMonth = st.wMonth
    wDay = st.wDay
End Function

                                                                                        '  " "
Public Function SetToday(Optional ByVal wYear As Integer, Optional ByVal wMonth As Integer, Optional ByVal wDay As Integer) As Boolean
    Dim st As SYSTEMTIME

    st.wYear = wYear
    st.wMonth = wMonth
    st.wDay = wDay

    Call SendMessage(hWnd, MCM_SETTODAY, vNull, st)
End Function

'  CallBack ( ) 

Public Sub zRaiseEvents(ByVal uMsg As Long)
    Select Case uMsg
        Case Is = MCN_SELCHANGE:    RaiseEvent SelChange
        Case Is = MCN_SELECT:       RaiseEvent ChangeSelected
    End Select
End Sub

'  CallBack ( ) 

Private Function GetData() As SYSTEMTIME
    Call SendMessage(hWnd, MCM_GETCURSEL, vNull, GetData)
End Function

Private Sub SetData(ByRef inVal As SYSTEMTIME)
    Call SendMessage(hWnd, MCM_SETCURSEL, vNull, inVal)
End Sub

Public Function LoWord(DWord As Long) As Integer
    LoWord = IIf(DWord And &H8000&, DWord Or &HFFFF0000, DWord And &HFFFF&)
End Function

Public Function HiWord(DWord As Long) As Integer
    HiWord = (DWord And &HFFFF0000) \ &H10000
End Function
