Attribute VB_Name = "mCalendar"
Option Explicit

'********************************************************************
'*             26.03.2004  (Team HomeWork)              *
'*                   e-mail: sne_pro@mail.ru                        *
'********************************************************************

Private Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32.dll" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GetParent Lib "user32.dll" (ByVal hWnd As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Private Type gbHWSubclassFrmData        '    
    BaseProc    As Long
    hWnd        As Long
End Type
Private Type gbHWSubclassCtlData        '       ...
    hWnd        As Long
    hWndPrnt    As Long
    mObj        As Long
End Type
Private Type NMHDR
    hWndFrom    As Long
    idFrom      As Long
    Code        As Long
End Type

Private frmData() As gbHWSubclassFrmData
Private ctlData() As gbHWSubclassCtlData

Public Sub SetCdrProc(ByRef mObj As cCalendar)
    Dim lng As Long
    If Not FindByKey(mObj.hWnd, False) = &HFFFF Then Exit Sub

    lng = UboundEx(False) + 1&
    ReDim Preserve ctlData(lng)

    ctlData(lng).hWnd = mObj.hWnd
    ctlData(lng).hWndPrnt = GetParent(ctlData(lng).hWnd)
    ctlData(lng).mObj = ObjPtr(mObj)

    If Not FindByKey(ctlData(lng).hWndPrnt, True) = &HFFFF Then Exit Sub
    lng = UboundEx(True) + 1&
    ReDim Preserve frmData(lng)

    frmData(lng).hWnd = GetParent(ctlData(lng).hWnd)
    frmData(lng).BaseProc = SetWindowLong(frmData(lng).hWnd, &HFFFC, AddressOf CalendarCallProc)
End Sub

Public Sub DelCdr(ByRef mObj As cCalendar)
    Dim fk      As Long, nIndex As Long
    Dim tmpData As gbHWSubclassCtlData

    nIndex = FindByKey(mObj.hWnd, False)
    If nIndex = &HFFFF Then Exit Sub

    tmpData = ctlData(nIndex)

    For fk = 0 To UboundEx(False)                           '       ...
        If Not nIndex = fk Then If ctlData(fk).hWndPrnt = tmpData.hWndPrnt Then Call RemoveCtl(nIndex, False): Exit Sub
    Next
    Call RemoveCtl(nIndex, False)

    nIndex = FindByKey(tmpData.hWndPrnt, True)              '   ,    
    Call SetWindowLong(frmData(nIndex).hWnd, &HFFFC, frmData(nIndex).BaseProc)
    Call RemoveCtl(nIndex, True)
End Sub

Private Function CalendarCallProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim FrmID As Long, CtlID As Long
    Dim tNM As NMHDR, Cdr As New cCalendar

    FrmID = FindByKey(hWnd, True)

    If uMsg = &H4E Then
        Call CopyMemory(tNM, ByVal lParam, Len(tNM))
        CtlID = FindByKey(tNM.hWndFrom, False)

        If Not CtlID = &HFFFF Then
            Call CopyMemory(Cdr, ctlData(CtlID).mObj, 4&)
            Call Cdr.zRaiseEvents(tNM.Code)
            Call CopyMemory(Cdr, 0&, 4&)
        End If
    End If

    CalendarCallProc = CallWindowProc(frmData(FrmID).BaseProc, hWnd, uMsg, wParam, lParam)
End Function

'       

Private Function UboundEx(ByVal bIsFrm As Boolean) As Long
    On Error Resume Next
    UboundEx = &HFFFF: If bIsFrm Then UboundEx = UBound(frmData) Else UboundEx = UBound(ctlData)
End Function

Private Function FindByKey(ByVal hWnd As Long, ByVal bIsFrm As Boolean) As Long
    Dim fk As Long: FindByKey = &HFFFF

    For fk = 0 To UboundEx(bIsFrm)
        If bIsFrm Then
            If hWnd = frmData(fk).hWnd Then FindByKey = fk: Exit For
        Else
            If hWnd = ctlData(fk).hWnd Then FindByKey = fk: Exit For
        End If
    Next
End Function

Private Function RemoveCtl(ByVal nIndex As Long, ByVal bIsFrm As Boolean) As Integer
    Dim ub As Long: ub = UboundEx(bIsFrm)

    If Not ub = 0 And Not ub = &HFFFF Then
        If bIsFrm Then
            If Not ub = nIndex Then Call CopyMemory(frmData(nIndex), frmData(nIndex + 1), Len(frmData(nIndex)) * (ub - nIndex))
            ReDim Preserve frmData(ub - 1)
        Else
            If Not ub = nIndex Then Call CopyMemory(ctlData(nIndex), ctlData(nIndex + 1), Len(ctlData(nIndex)) * (ub - nIndex))
            ReDim Preserve ctlData(ub - 1)
        End If
    Else
        If bIsFrm Then Erase frmData _
                  Else Erase ctlData
    End If
End Function
