VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cDateTimePicker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'********************************************************************
'*             22.02.2004  (Team HomeWork)              *
'*                   e-mail: sne_pro@mail.ru                        *
'********************************************************************

Private Declare Function CreateWindowEx Lib "user32.dll" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function InitCommonControlsEx Lib "comctl32.dll" (ByRef InitCommonCtl As INITCOMCTLSEX) As Long
Private Declare Function DestroyWindow Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function EnableWindow Lib "user32" (ByVal hwnd As Long, ByVal fEnable As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long

Private Declare Sub GetLocalTime Lib "kernel32.dll" (lpSystemTime As SYSTEMTIME)
Private Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long
Private Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal H As Long, ByVal W As Long, ByVal E As Long, ByVal O As Long, ByVal W As Long, ByVal i As Long, ByVal u As Long, ByVal S As Long, ByVal C As Long, ByVal OP As Long, ByVal CP As Long, ByVal Q As Long, ByVal PAF As Long, ByVal F As String) As Long
Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32.dll" (ByVal hDC As Long, ByVal nIndex As Long) As Long
Private Declare Function MulDiv Lib "kernel32.dll" (ByVal nNumber As Long, ByVal nNumerator As Long, ByVal nDenominator As Long) As Long
Private Declare Function GetTextMetrics Lib "gdi32.dll" Alias "GetTextMetricsA" (ByVal hDC As Long, lpMetrics As TEXTMETRIC) As Long
Private Declare Function GetTextFace Lib "gdi32.dll" Alias "GetTextFaceA" (ByVal hDC As Long, ByVal nCount As Long, ByVal lpFacename As String) As Long
Private Declare Function GetDC Lib "user32.dll" (ByVal hwnd As Long) As Long

Public Enum gbHWDateTimePickerStyles
    DTS_APPCANPARSE = &H10
    DTS_LONGDATEFORMAT = &H4
    DTS_RIGHTALIGN = &H20
    DTS_SHOWNONE = &H2
    DTS_SHORTDATEFORMAT = &H0
    DTS_SHORTDATECENTURYFORMAT = &HC
    DTS_TIMEFORMAT = &H9
    DTS_UPDOWN = &H1
End Enum
Public Enum gbHWDateTimeColor
    MCSC_BACKGROUND = 0
    MCSC_MONTHBK = 4
    MCSC_TEXT = 1
    MCSC_TITLEBK = 2
    MCSC_TITLETEXT = 3
    MCSC_TRAILINGTEXT = 5
End Enum
Public Enum gbHWDateTimeRetVal
    wYear = 1
    wMonth = 2
    wDayOfWeek = 3
    wDay = 4
    wHour = 5
    wMinute = 6
    wSecond = 7
End Enum

Private Type INITCOMCTLSEX
    dwSize  As Long
    dwICC   As Long
End Type
Private Type TEXTMETRIC
    tmHeight As Long
    tmAscent As Long
    tmDescent As Long
    tmInternalLeading As Long
    tmExternalLeading As Long
    tmAveCharWidth As Long
    tmMaxCharWidth As Long
    tmWeight As Long
    tmOverhang As Long
    tmDigitizedAspectX As Long
    tmDigitizedAspectY As Long
    tmFirstChar As Byte
    tmLastChar As Byte
    tmDefaultChar As Byte
    tmBreakChar As Byte
    tmItalic As Byte
    tmUnderlined As Byte
    tmStruckOut As Byte
    tmPitchAndFamily As Byte
    tmCharSet As Byte
End Type
Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Private Type NMHDR
    hWndFrom    As Long
    idFrom      As Long
    Code        As Long
End Type
Private Type NMDATETIMEWMKEYDOWN
    nNMHdr      As NMHDR
    nVirtKey    As Integer
    pszFormat   As Long
    st          As SYSTEMTIME
End Type

Private Const GWL_STYLE = (-16)
Private Const WS_DISABLED = &H8000000

Private Const DTM_SETMCCOLOR        As Long = &H1006
Private Const DTM_GETMCCOLOR        As Long = &H1007
Private Const DTM_SETMCFONT         As Long = &H1009
Private Const DTM_GETMCFONT         As Long = &H100A
Private Const DTM_GETSYSTEMTIME     As Long = &H1001
Private Const DTM_SETSYSTEMTIME     As Long = &H1002
Private Const DTM_SETFORMATA        As Long = &H1005

Private Const DTN_CLOSEUP           As Long = (-753)
Private Const DTN_DATETIMECHANGE    As Long = (-759)
Private Const DTN_DROPDOWN          As Long = (-754)
Private Const DTN_USERSTRINGA       As Long = (-758)
Private Const DTN_WMKEYDOWNA        As Long = (-757)
Private Const NM_SETFOCUS           As Long = (-7)
Private Const NM_KILLFOCUS          As Long = (-8)

Private Const WM_SETFONT        As Long = &H30
Private Const WM_GETFONT        As Long = &H31

Private Const WS_CHILD          As Long = &H40000000
Private Const WS_TABSTOP        As Long = &H10000
Private Const WS_VISIBLE        As Long = &H10000000
Private Const vNull             As Long = 0&

Public Event ClouseUp()
Public Event Change()
Public Event DropDown()
Public Event EndUserChange()
Public Event GotFocus()
Public Event LostFocus()

Private mShNone As Boolean

Private hPicker As Long, tOldDateTime As SYSTEMTIME
Private hMtFont As Long, hPkFont As Long

Public Function Create(ByVal hParent As Long, _
                       ByVal dwFlags As gbHWDateTimePickerStyles, _
                       ByVal nLeft As Long, _
                       ByVal nTop As Long, _
                       ByVal nWidth As Long, _
                       ByVal nHeight As Long) As Boolean                                ' 
    Dim ictl As INITCOMCTLSEX
    ictl.dwSize = Len(ictl)
    ictl.dwICC = &H100

    Call InitCommonControlsEx(ictl)
    hPicker = CreateWindowEx(0&, "SysDateTimePick32", "HomeWork DateTimePicker", WS_CHILD Or WS_TABSTOP Or WS_VISIBLE Or dwFlags, nLeft, nTop, nWidth, nHeight, hParent, 0&, App.hInstance, 0&)

    Call SendMessage(hPicker, DTM_SETMCFONT, SendMessage(hParent, WM_GETFONT, vNull, vNull), ByVal vbNull)
    Call mDateTimePicker.SetDTPProc(Me)

    Call GetLocalTime(tOldDateTime)                                                     '  

    Create = Not (hPicker = vNull)
End Function

Public Sub Destroy()                                                                    ' 
    Call mDateTimePicker.DelDTP(Me)

    If hMtFont Then Call DeleteObject(hMtFont)
    If hPkFont Then Call DeleteObject(hPkFont)

    Call DestroyWindow(hPicker)
End Sub

Public Property Get Colors(ByVal RetVal As gbHWDateTimeColor) As Long                   ' 
    Colors = SendMessage(hPicker, DTM_GETMCCOLOR, RetVal, 0&)
End Property
Public Property Let Colors(ByVal RetVal As gbHWDateTimeColor, ByVal newValue As Long)
    Call SendMessage(hPicker, DTM_SETMCCOLOR, RetVal, ByVal newValue)
End Property

Public Property Get Data(ByVal TypVal As gbHWDateTimeRetVal) As Long                    ' , 
    Dim sTime As SYSTEMTIME
    Call SendMessage(hPicker, DTM_GETSYSTEMTIME, vNull, sTime)

    Data = Choose(TypVal, sTime.wYear, sTime.wMonth, sTime.wDayOfWeek, sTime.wDay, sTime.wHour, sTime.wMinute, sTime.wSecond)
End Property
Public Property Let Data(ByVal TypVal As gbHWDateTimeRetVal, ByVal inVal As Long)
    Dim lFlag As Long
    lFlag = SendMessage(hPicker, DTM_GETSYSTEMTIME, vNull, tOldDateTime)

    Select Case TypVal
        Case Is = wYear:        tOldDateTime.wYear = inVal
        Case Is = wMonth:       tOldDateTime.wMonth = inVal
        Case Is = wDayOfWeek:   tOldDateTime.wDayOfWeek = inVal
        Case Is = wDay:         tOldDateTime.wDay = inVal
        Case Is = wHour:        tOldDateTime.wHour = inVal
        Case Is = wMinute:      tOldDateTime.wMinute = inVal
        Case Is = wSecond:      tOldDateTime.wSecond = inVal
    End Select

    Call SendMessage(hPicker, DTM_SETSYSTEMTIME, lFlag, tOldDateTime)
End Property

Public Property Let dtpFlag(ByVal newVal As Boolean)                                    '   ;)
    Call SendMessage(hPicker, DTM_SETSYSTEMTIME, ByVal Abs(Not newVal), tOldDateTime)
End Property
Public Property Get dtpFlag() As Boolean
    Dim sTime As SYSTEMTIME
    dtpFlag = (SendMessage(hPicker, DTM_GETSYSTEMTIME, vNull, sTime) = vNull)
End Property


Public Property Let CalendarFont(ByVal newFnt As StdFont)                               '  
    If hMtFont Then Call DeleteObject(hMtFont)

    hMtFont = CreateFont(ByVal -MulDiv(newFnt.Size, GetDeviceCaps(GetDC(hPicker), 90), 72), 0&, 0&, 0&, newFnt.Weight, newFnt.Italic, newFnt.Underline, newFnt.Strikethrough, newFnt.Charset, 0&, 0&, 0&, 0&, newFnt.Name)
    Call SendMessage(hPicker, DTM_SETMCFONT, hMtFont, ByVal vbNull)
End Property
Public Property Get CalendarFont() As StdFont
    Dim hOldFnt As Long, hDC As Long, lLen As Long
    Dim sBuffer As String, lpMetr  As TEXTMETRIC

    Set CalendarFont = New StdFont

    hDC = GetDC(hPicker)
    hOldFnt = SelectObject(hDC, SendMessage(hPicker, DTM_GETMCFONT, vNull, vNull))

    sBuffer = String$(80, vNull)
    lLen = GetTextFace(hDC, 80, sBuffer)

    Call GetTextMetrics(hDC, lpMetr)

    CalendarFont.Name = Left$(sBuffer, lLen)
    CalendarFont.Charset = lpMetr.tmCharSet
    CalendarFont.Italic = lpMetr.tmItalic
    CalendarFont.Size = MulDiv(lpMetr.tmHeight, 60, GetDeviceCaps(GetDC(hPicker), 90))
    CalendarFont.Strikethrough = lpMetr.tmStruckOut
    CalendarFont.Underline = lpMetr.tmUnderlined
    CalendarFont.Weight = lpMetr.tmWeight

    Call SelectObject(hDC, hOldFnt)
End Property

Public Property Let EditFont(ByVal newFnt As StdFont)                                   '    
    If hPkFont Then Call DeleteObject(hPkFont)

    hPkFont = CreateFont(ByVal -MulDiv(newFnt.Size, GetDeviceCaps(GetDC(hPicker), 90), 72), 0&, 0&, 0&, newFnt.Weight, newFnt.Italic, newFnt.Underline, newFnt.Strikethrough, newFnt.Charset, 0&, 0&, 0&, 0&, newFnt.Name)
    Call SendMessage(hPicker, WM_SETFONT, hPkFont, ByVal vbNull)
End Property
Public Property Get EditFont() As StdFont
    Dim hDC As Long, lLen As Long
    Dim sBuffer As String, lpMetr  As TEXTMETRIC

    Set EditFont = New StdFont

    hDC = GetDC(hPicker)

    sBuffer = String$(80, vNull)
    lLen = GetTextFace(hDC, 80, sBuffer)

    Call GetTextMetrics(hDC, lpMetr)

    EditFont.Name = Left$(sBuffer, lLen)
    EditFont.Charset = lpMetr.tmCharSet
    EditFont.Italic = lpMetr.tmItalic
    EditFont.Size = MulDiv(lpMetr.tmHeight, 60, GetDeviceCaps(GetDC(hPicker), 90))
    EditFont.Strikethrough = lpMetr.tmStruckOut
    EditFont.Underline = lpMetr.tmUnderlined
    EditFont.Weight = lpMetr.tmWeight
End Property

Public Property Let Enabled(ByVal blnEnable As Boolean)
        EnableWindow hPicker, blnEnable
End Property

Public Property Get Enabled() As Boolean
        Dim lngGWL As Long
        lngGWL = GetWindowLong(hPicker, GWL_STYLE)
        If (lngGWL And WS_DISABLED) Then
            Enabled = False
        Else
            Enabled = True
        End If
End Property

Public Property Let Format(ByVal inValue As String)
    Call SendMessage(hPicker, DTM_SETFORMATA, vNull, ByVal inValue)
End Property

Public Property Get hwnd() As Long
    hwnd = hPicker
End Property

Public Sub zRaiseEvents(ByVal uMsg As Long)
    Select Case uMsg
        Case Is = DTN_CLOSEUP:          RaiseEvent ClouseUp
        Case Is = DTN_DATETIMECHANGE:   RaiseEvent Change
        Case Is = DTN_DROPDOWN:         RaiseEvent DropDown
        Case Is = DTN_USERSTRINGA:      RaiseEvent EndUserChange
        Case Is = NM_KILLFOCUS:         RaiseEvent LostFocus
        Case Is = NM_SETFOCUS:          RaiseEvent GotFocus
    End Select
End Sub
