VERSION 5.00
Begin VB.UserControl SysIpAddress32 
   ClientHeight    =   285
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2700
   ScaleHeight     =   285
   ScaleWidth      =   2700
End
Attribute VB_Name = "SysIpAddress32"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Copyright by ALXR: Founder1e2[at]gmail[dot]com

Private Declare Function EnableWindow Lib "user32.dll" (ByVal hWnd As Long, ByVal bEnabled As Boolean) As Long
Private Declare Function IsWindowEnabled Lib "user32.dll" (ByVal hWnd As Long) As Long
Private Declare Function GetWindowLongA Lib "user32.dll" (ByVal hWnd As Long, ByVal dwValue As Long) As Long
Private Declare Function SendMessageA Lib "user32.dll" (ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Any) As Long
Private Declare Function SendMsg Lib "user32.dll" Alias "SendMessageA" (ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function CreateWindowExA Lib "user32" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Sub InitCommonControlsEx Lib "comctl32.dll" (ICC As ICC)
Private Declare Function CreateFontA Lib "gdi32" (ByVal h As Long, ByVal w As Long, ByVal E As Long, ByVal O As Long, ByVal w As Long, ByVal i As Long, ByVal u As Long, ByVal S As Long, ByVal c As Long, ByVal OP As Long, ByVal CP As Long, ByVal Q As Long, ByVal PAF As Long, ByVal f As String) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long
Private Declare Function inet_addr Lib "wsock32.dll" (ByVal lp As String) As Long
Private Declare Function ReverseIP Lib "wsock32.dll" Alias "htonl" (ByVal hostlong As Long) As Long
Private Declare Function CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (CopyTO As Any, CopyFROM As Any, ByVal uBytes As Long) As Long
Private Declare Function IsBadReadPtr Lib "kernel32.dll" (ByVal lp As Any, ByVal uBytes As Long) As Long
Private Declare Function MoveWindow Lib "user32" (ByVal hWnd As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long

Private Const IPM_CLEARADDRESS As Long = 1124
Private Const IPM_SETADDRESS As Long = 1125
Private Const IPM_GETADDRESS As Long = 1126
Private Const IPM_SETRANGE As Long = 1127
Private Const IPM_SETFOCUS As Long = 1128
Private Const IPM_ISBLANK As Long = 1129

Private Type ICC
  dwLength As Long
  dwICC As Long
End Type

Private Type FIELD
  hWnd As Long
  lpfnWndProc As Long
  byLow As Byte
  byHigh As Byte
  iUnknown As Integer
End Type

Dim hIp As Long

Private Sub Class_Initialize()
  Dim lpicc As ICC
  lpicc.dwLength = Len(lpicc)
  lpicc.dwICC = &H3FFF&
  Call InitCommonControlsEx(lpicc)
End Sub

Private Sub Class_Terminate()
  DestroyWindow hIp
End Sub

Private Function LIP2IP(ByVal LIP As Long) As String
  Dim b(1 To 4) As Byte
  CopyMemory b(1), LIP, 4
  LIP2IP = CStr(b(1)) & "." & CStr(b(2)) & "." & CStr(b(3)) & "." & CStr(b(4))
End Function

Private Function GetField(ByVal i As Integer) As FIELD
  ' Is this code realy working with all versions of comctl32.dll ?
  Const IPADDR_SIZE As Long = 24
  Dim h As Long
  h = GetWindowLongA(hIp, -21)
  If IsBadReadPtr(h, IPADDR_SIZE + 4 * Len(GetField)) = 0 And i >= 1 And i <= 4 Then
      CopyMemory GetField, ByVal (h + IPADDR_SIZE + Len(GetField) * (i - 1)), Len(GetField)
  End If
End Function

Private Sub Create(hParent As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, Optional ByVal dwStyle As Long, Optional ByVal dwExStyle As Long, Optional ByVal bVisible As Boolean = True)
  dwStyle = dwStyle Or &H40000000
  If bVisible Then dwStyle = dwStyle Or &H10000000
  hIp = CreateWindowExA(dwExStyle, "SysIpAddress32", "", dwStyle, X, Y, cx, cy, hParent, 0, App.hInstance, ByVal 0&)
  If hIp <> 0 Then
      Dim hFont As Long
      hFont = CreateFontA(-UserControl.FontSize * GetDeviceCaps(UserControl.hDC, 90) \ 72, 0, 0, 0, IIf(70, UserControl.FontBold, 0), UserControl.FontItalic, UserControl.FontUnderline, UserControl.FontStrikethru, 1, 0, 0, 0, 0, UserControl.FontName)
      SendMessageA hIp, 48, hFont, 1&
      ' We don't needing to destroy font because it will be destroyed with this control.
  End If
End Sub

Property Get Value() As String
Attribute Value.VB_UserMemId = 0
  Value = LIP2IP(DwordIP)
End Property

Property Get DwordIP() As Long
  SendMessageA hIp, IPM_GETADDRESS, 0, VarPtr(DwordIP)
  DwordIP = ReverseIP(DwordIP)
End Property

Property Let Value(ByVal lp As String)
  DwordIP = ReverseIP(inet_addr(lp))
End Property

Property Let DwordIP(ByVal dw As Long)
  SendMessageA hIp, IPM_SETADDRESS, 0, dw
End Property

Function IsBlank() As Boolean
  IsBlank = SendMessageA(hIp, IPM_ISBLANK, 0, 0&)
End Function

Property Get Enable(ByVal i As Long) As Boolean
  Enable = IsWindowEnabled(GetField(i).hWnd)
End Property

Property Let Enable(ByVal i As Long, ByVal bEnabled As Boolean)
  EnableWindow GetField(i).hWnd, bEnabled
End Property

Private Sub UserControl_Initialize()
  ScaleMode = vbPixels
  Call Create(UserControl.hWnd, 0, 0, ScaleWidth, ScaleHeight, 1, 0, True)
End Sub

Private Sub UserControl_Resize()
  Call MoveWindow(hIp, 0, 0, ScaleWidth, ScaleHeight, 1)
End Sub
