VERSION 5.00
Begin VB.UserControl DateTimePick 
   ClientHeight    =   285
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1965
   ScaleHeight     =   285
   ScaleWidth      =   1965
End
Attribute VB_Name = "DateTimePick"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Created by SCINER: lenar2003mail.ru
'14/11/2006 14:27

Private Const GDT_ERROR = -1
Private Const GDT_VALID = 0
Private Const GDT_NONE = 1
Private Const GDTR_MIN = &H1
Private Const GDTR_MAX = &H2

Private Const ICC_LISTVIEW_CLASSES = &H1       ' listview, header
Private Const ICC_TREEVIEW_CLASSES = &H2       ' treeview, tooltips
Private Const ICC_BAR_CLASSES = &H4            ' toolbar, statusbar, trackbar, tooltips
Private Const ICC_TAB_CLASSES = &H8            ' tab, tooltips
Private Const ICC_UPDOWN_CLASS = &H10          ' updown
Private Const ICC_PROGRESS_CLASS = &H20        ' progress
Private Const ICC_HOTKEY_CLASS = &H40          ' hotkey
Private Const ICC_ANIMATE_CLASS = &H80         ' animate
Private Const ICC_WIN95_CLASSES = &HFF
Private Const ICC_DATE_CLASSES = &H100         ' month picker, date picker, time picker, updown
Private Const ICC_USEREX_CLASSES = &H200       ' comboex
Private Const ICC_COOL_CLASSES = &H400         ' rebar (coolbar) control
Private Const ICC_INTERNET_CLASSES = &H800
Private Const ICC_PAGESCROLLER_CLASS = &H1000  ' page scroller
Private Const ICC_NATIVEFNTCTL_CLASS = &H2000  ' native font control

Private Const WS_VISIBLE = &H10000000
Private Const WS_CHILD = &H40000000
Private Const WS_TABSTOP As Long = &H10000

Private Const DTM_FIRST = &H1000
Private Const DTM_GETSYSTEMTIME = DTM_FIRST + 1
Private Const DTM_SETRANGE = DTM_FIRST + 4
Private Const DTM_SETSYSTEMTIME = DTM_FIRST + 2

Private Type InitCommonControlsExType
  dwSize As Long 'size of this structure
  dwICC As Long 'flags indicating which classes to be initialized
End Type

Private Type SYSTEMTIME
  wYear As Integer
  wMonth As Integer
  wDayOfWeek As Integer
  wDay As Integer
  wHour As Integer
  wMinute As Integer
  wSecond As Integer
  wMilliseconds As Integer
End Type

Private Type POINTAPI
  x As Long
  y As Long
End Type

'Private Declare Sub InitCommonControls Lib "Comctl32" ()
Private Declare Function InitCommonControlsEx Lib "comctl32" (Init As InitCommonControlsExType) As Boolean
Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function MoveWindow Lib "user32" (ByVal hWnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Private Declare Function SetFocus Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long
Private Declare Function SetCapture Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function ShowWindow Lib "user32" (ByVal hWnd As Long, ByVal nCmdShow As Long) As Long
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Private Const WM_MOUSEACTIVATE = &H21
Private Const WM_SETFOCUS = &H7
Private Const WM_NCLBUTTONUP = &HA2

Dim mWnd As Long

'-   =(
'Property Let Max(ByVal dDate As Date)
'  Dim ST As SYSTEMTIME
'  With ST
'    .wDay = Day(dDate)
'    .wMonth = Month(dDate)
'    .wYear = Year(dDate)
'  End With
'  Call SendMessage(mWnd, DTM_SETRANGE, GDTR_MAX, ST)
'End Property

'-   =(
'Property Let Min(ByVal dtDate As Date)
'  Dim ST As SYSTEMTIME
'  With ST
'    .wDay = Day(dtDate)
'    .wMonth = Month(dtDate)
'    .wYear = Year(dtDate)
'  End With
'  Call SendMessage(mWnd, DTM_SETRANGE, GDTR_MIN, ST)
'End Property

Property Get Value() As Date
Attribute Value.VB_UserMemId = 0
  Dim ST As SYSTEMTIME
  Call SendMessage(mWnd, DTM_GETSYSTEMTIME, 0, ST)
  With ST
    Value = CDate(CStr(.wDay) & "/" & CStr(.wMonth) & "/" & CStr(.wYear))
  End With
End Property

Property Let Value(ByVal dtDate As Date)
  Dim ST As SYSTEMTIME
  With ST
    .wDay = Day(dtDate)
    .wMonth = Month(dtDate)
    .wYear = Year(dtDate)
  End With
  Call SendMessage(mWnd, DTM_SETSYSTEMTIME, GDT_VALID, ST)
End Property

Private Sub UserControl_EnterFocus()
  Call SetFocus(mWnd)
End Sub

Private Sub UserControl_Initialize()
  Call CreateControl
End Sub

Private Sub CreateControl()
  Const IE3_INSTALLED = True
  Dim initcc As InitCommonControlsExType
  UserControl.ScaleMode = vbPixels
  If IE3_INSTALLED = True Then
    initcc.dwSize = Len(initcc)
    initcc.dwICC = ICC_DATE_CLASSES
    InitCommonControlsEx initcc
  Else
    'Call InitCommonControls
  End If
  mWnd = CreateWindowEx(0, "SysDateTimePick32", "KPD UpDown Control", WS_VISIBLE Or WS_CHILD Or WS_TABSTOP, _
                        0, 0, ScaleWidth, ScaleHeight, UserControl.hWnd, ByVal 0&, ByVal 0&, ByVal 0&)
End Sub

Private Sub UserControl_Resize()
  Call MoveWindow(mWnd, 0, 0, ScaleWidth, ScaleHeight, 1)
End Sub

Private Sub UserControl_Terminate()
  Call DestroyWindow(mWnd)
End Sub
