VERSION 5.00
Begin VB.UserControl ListView 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ClipControls    =   0   'False
   HasDC           =   0   'False
   KeyPreview      =   -1  'True
   ScaleHeight     =   3600
   ScaleWidth      =   4800
End
Attribute VB_Name = "ListView"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Created by SCINER: lenar2003@mail.ru
'Private m_uIPAO As IPAOHookStructListView

'
Event KeyDown(KeyCode As Integer, Shift As Integer)
Event ItemCheck(index As Long, ByVal Key As String)
Event ItemClick(index As Long, ByVal Key As String)
Event MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Event MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)

Private Const WC_LISTVIEW = "SysListView32"
Private Const SW_SHOW = 5


Private Const H_MAX                  As Long = &HFFFF + 1
Private Const NM_FIRST               As Long = H_MAX
Private Const NM_CLICK               As Long = (NM_FIRST - 2)
Private Const NM_DBLCLK              As Long = (NM_FIRST - 3)
Private Const NM_RCLICK              As Long = (NM_FIRST - 5)
Private Const NM_RDBLCLK             As Long = (NM_FIRST - 6)
Private Const NM_SETFOCUS            As Long = (NM_FIRST - 7)
Private Const NM_CUSTOMDRAW          As Long = (NM_FIRST - 12)

Private Const LVIS_SELECTED = &H2
Private Const LVIS_STATEIMAGEMASK = &HF000

Private Const WS_EX_CLIENTEDGE = &H200
Private Const WS_CHILD = &H40000000
Private Const WS_TABSTOP As Long = &H10000

Private Const WM_KEYUP = &H101
Private Const WM_USER = &H400
Private Const WM_KEYDOWN = &H100
Private Const WM_NOTIFY                    As Long = &H4E
Private Const WM_SETFOCUS = &H7
Private Const WM_LBUTTONDOWN = &H201
Private Const WM_LBUTTONUP = &H202
Private Const WM_RBUTTONDOWN = &H204
Private Const WM_RBUTTONUP = &H205
Private Const WM_MBUTTONDOWN = &H207
Private Const WM_MBUTTONUP = &H208
Private Const WM_MOUSEMOVE = &H200

Private Const GWL_EXSTYLE As Long = (-20)
Private Const GWL_WNDPROC = (-4)

Private Const IDC_LISTVIEW = WM_USER + 2130

Private Const HDM_FIRST                    As Long = &H1200
Private Const HDM_GETITEMCOUNT             As Long = (HDM_FIRST + 0)
Private Const HDM_INSERTITEM               As Long = (HDM_FIRST + 1)
Private Const HDM_DELETEITEM               As Long = (HDM_FIRST + 2)
Private Const HDM_GETITEM                  As Long = (HDM_FIRST + 3)
Private Const HDM_SETITEM                  As Long = (HDM_FIRST + 4)
Private Const HDM_LAYOUT                   As Long = (HDM_FIRST + 5)
Private Const HDM_HITTEST                  As Long = (HDM_FIRST + 6)
Private Const HDM_GETITEMRECT              As Long = (HDM_FIRST + 7)
Private Const HDM_SETIMAGELIST             As Long = (HDM_FIRST + 8)
Private Const HDM_GETIMAGELIST             As Long = (HDM_FIRST + 9)
Private Const HDM_ORDERTOINDEX             As Long = (HDM_FIRST + 15)

'Private Const LVM_FIRST                    As Long = &H1000
Private Const LVM_GETBKCOLOR               As Long = (LVM_FIRST + 0)
Private Const LVM_SETBKCOLOR               As Long = (LVM_FIRST + 1)
Private Const LVM_GETIMAGELIST             As Long = (LVM_FIRST + 2)
Private Const LVM_SETIMAGELIST             As Long = (LVM_FIRST + 3)
Private Const LVM_GETITEMCOUNT             As Long = (LVM_FIRST + 4)
Private Const LVM_GETITEM                  As Long = (LVM_FIRST + 5)
Private Const LVM_SETITEM                  As Long = (LVM_FIRST + 6)
Private Const LVM_INSERTITEM               As Long = (LVM_FIRST + 7)
Private Const LVM_DELETEITEM               As Long = (LVM_FIRST + 8)
Private Const LVM_DELETEALLITEMS           As Long = (LVM_FIRST + 9)
Private Const LVM_GETNEXTITEM              As Long = (LVM_FIRST + 12)
Private Const LVM_FINDITEM                 As Long = (LVM_FIRST + 13)
Private Const LVM_HITTEST                  As Long = (LVM_FIRST + 18)
Private Const LVM_ENSUREVISIBLE            As Long = (LVM_FIRST + 19)
Private Const LVM_SCROLL                   As Long = (LVM_FIRST + 20)
Private Const LVM_REDRAWITEMS              As Long = (LVM_FIRST + 21)
Private Const LVM_ARRANGE                  As Long = (LVM_FIRST + 22)
Private Const LVM_EDITLABEL                As Long = (LVM_FIRST + 23)
Private Const LVM_GETEDITCONTROL           As Long = (LVM_FIRST + 24)
Private Const LVM_GETCOLUMN                As Long = (LVM_FIRST + 25)
Private Const LVM_SETCOLUMN                As Long = (LVM_FIRST + 26)
Private Const LVM_INSERTCOLUMN             As Long = (LVM_FIRST + 27)
Private Const LVM_DELETECOLUMN             As Long = (LVM_FIRST + 28)
Private Const LVM_GETCOLUMNWIDTH           As Long = (LVM_FIRST + 29)
Private Const LVM_SETCOLUMNWIDTH           As Long = (LVM_FIRST + 30)
Private Const LVM_GETHEADER                As Long = (LVM_FIRST + 31)
Private Const LVM_GETTEXTCOLOR             As Long = (LVM_FIRST + 35)
Private Const LVM_SETTEXTCOLOR             As Long = (LVM_FIRST + 36)
Private Const LVM_GETTEXTBKCOLOR           As Long = (LVM_FIRST + 37)
Private Const LVM_SETTEXTBKCOLOR           As Long = (LVM_FIRST + 38)
Private Const LVM_UPDATE                   As Long = (LVM_FIRST + 42)
Private Const LVM_SETITEMSTATE             As Long = (LVM_FIRST + 43)
Private Const LVM_GETITEMSTATE             As Long = (LVM_FIRST + 44)
'Private Const LVM_GETITEMTEXT              As Long = (LVM_FIRST + 45)
Private Const LVM_SETITEMTEXT              As Long = (LVM_FIRST + 46)
Private Const LVM_SORTITEMS                As Long = (LVM_FIRST + 48)
Private Const LVM_GETSELECTEDCOUNT         As Long = (LVM_FIRST + 50)
Private Const LVM_SETEXTENDEDLISTVIEWSTYLE As Long = (LVM_FIRST + 54)
Private Const LVM_GETEXTENDEDLISTVIEWSTYLE As Long = (LVM_FIRST + 55)
Private Const LVM_SETCOLUMNORDERARRAY      As Long = (LVM_FIRST + 58)
Private Const LVM_GETCOLUMNORDERARRAY      As Long = (LVM_FIRST + 59)
Private Const LVM_SETHOTITEM               As Long = (LVM_FIRST + 60)
Private Const LVM_GETHOTITEM               As Long = (LVM_FIRST + 61)
Private Const LVM_SETHOTCURSOR             As Long = (LVM_FIRST + 62)
Private Const LVM_GETHOTCURSOR             As Long = (LVM_FIRST + 63)
Private Const LVM_SETBKIMAGE               As Long = (LVM_FIRST + 68)
Private Const LVM_GETBKIMAGE               As Long = (LVM_FIRST + 69)
Private Const LVM_SORTITEMSEX              As Long = (LVM_FIRST + 81)
Private Const LVM_SETVIEW                  As Long = (LVM_FIRST + 142)
Private Const LVM_GETVIEW                  As Long = (LVM_FIRST + 143)

'Private Const LVIF_TEXT           As Long = &H1
'Private Const LVIF_IMAGE          As Long = &H2
'Private Const LVIF_PARAM          As Long = &H4
'Private Const LVIF_STATE          As Long = &H8
'Private Const LVIF_INDENT         As Long = &H10
'Private Const LVIF_GROUPID        As Long = &H100
'Private Const LVIF_COLUMNS        As Long = &H200

Private Type RECT2
  x1 As Long
  y1 As Long
  X2 As Long
  Y2 As Long
End Type

Private Type NMHDR
  hwndFrom As Long
  idfrom As Long
  code As Long
End Type

Private Type NMTOOLTIPSCREATED
  hdr As NMHDR
  hwndToolTips As Long
End Type

Private Type POINTAPI
  x As Long
  y As Long
End Type

Private Type NMLISTVIEW
  hdr       As NMHDR
  iItem     As Long
  iSubItem  As Long
  uNewState As Long
  uOldState As Long
  uChanged  As Long
  ptAction  As POINTAPI
  lParam    As Long
End Type

Private Type HDHITTESTINFO
  pt    As POINTAPI
  flags As Long
  iItem As Long
End Type

Public Enum LV_MESSAGES
  HDN_FIRST = -300
  HDN_ITEMCHANGING = (HDN_FIRST - 0)
  HDN_ITEMCLICK = (HDN_FIRST - 2)
  HDN_ITEMDBLCLICK = (HDN_FIRST - 3)
  HDN_DIVIDERDBLCLICK = (HDN_FIRST - 5)
  HDN_BEGINTRACK = (HDN_FIRST - 6)
  HDN_ENDTRACK = (HDN_FIRST - 7)
  HDN_TRACK = (HDN_FIRST - 8)
  HDN_GETDISPINFO = (HDN_FIRST - 9)
  HDN_BEGINDRAG = (HDN_FIRST - 10)
  HDN_ENDDRAG = (HDN_FIRST - 11)

  LVN_FIRST = 0 - 100                   ' listview
  LVN_LAST = 0 - 199
  LVN_ITEMCHANGING = LVN_FIRST - 0
  LVN_ITEMCHANGED = LVN_FIRST - 1
End Enum

Public Enum eSortAsConst
  stText = 0
  stIndex = 1
  stDate = 2
  stNumber = 3
End Enum

Public Enum eSortOrderConstants
    '[soDefault] = 0
    [soAscending] = 1
    [soDescending] = -1
End Enum

Public Enum AlignConsts
  LVCFMT_LEFT = &H0
  LVCFMT_RIGHT = &H1
  LVCFMT_CENTER = &H2
End Enum

Private Enum LVENUMS
  LVCF_FMT = &H1
  LVCF_WIDTH = &H2
  LVCF_TEXT = &H4
  LVCF_SUBITEM = &H8
  LVCF_IMAGE = &H10
  LVCF_ORDER = &H20
  LVCFMT_JUSTIFYMASK = &H3
  LVCFMT_IMAGE = &H800
  LVCFMT_BITMAP_ON_RIGHT = &H1000
  LVCFMT_COL_HAS_IMAGES = &H8000
End Enum

Private Type LV_COLUMN
  Mask As Long
  fmt As Long
  cx As Long
  pszText As Long
  cchTextMax As Long
  iSubItem As Long
  iImage As Long
  iOrder As Long
End Type

Public Enum eListViewStyle
  LVS_ICON = &H0
  LVS_REPORT = &H1
  LVS_SMALLICON = &H2
  LVS_LIST = &H3
End Enum

Private Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Private Const GWL_STYLE = (-16)

' LVM_GET/SETIMAGELIST wParam
'Public Enum ImageListSize
'  LVSIL_NORMAL = 0
'  LVSIL_SMALL = 1
'End Enum

Private Const LVM_SETEXTENDEDSTYLE      As Long = (LVM_FIRST + 54)
Private Const LVM_GETEXTENDEDSTYLE      As Long = (LVM_FIRST + 55)

' 
Private Const LVS_SINGLESEL            As Long = &H4
Private Const LVS_SHOWSELALWAYS        As Long = &H8
Private Const LVS_AUTOARRANGE          As Long = &H100

'  
Private Const LVS_EX_GRIDLINES          As Long = &H1&
Private Const LVS_EX_DOUBLEBUFFER       As Long = &H10000
Private Const LVS_EX_FLATSB             As Long = &H100&
Private Const LVS_EX_SUBITEMIMAGES      As Long = &H2&
Private Const LVS_EX_CHECKBOXES         As Long = &H4&
Private Const LVS_EX_INFOTIP            As Long = &H400&
Private Const LVS_EX_LABELTIP           As Long = &H4000&
Private Const LVS_EX_TRACKSELECT        As Long = &H8&
Private Const LVS_EX_HEADERDRAGDROP     As Long = &H10&
Private Const LVS_EX_FULLROWSELECT      As Long = &H20&
Private Const LVS_EX_ONECLICKACTIVATE   As Long = &H40&
Private Const LVS_EX_BORDERSELECT       As Long = &H8000&
Private Const LVS_EX_UNDERLINEHOT       As Long = &H800&

Private Const LVSCW_AUTOSIZE As Long = -1
Private Const LVSCW_AUTOSIZE_USEHEADER As Long = -2 'Note: On last column, its width fills remaining width

Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function ShowWindow Lib "user32" (ByVal hWnd As Long, ByVal nCmdShow As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function MoveWindow Lib "user32" (ByVal hWnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
'Private Declare Sub InitCommonControls Lib "Comctl32" ()
Private Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function IsWindowVisible Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function ScreenToClient Lib "user32" (ByVal hWnd As Long, lpPoint As POINTAPI) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

'  
Private Const HEAP_ZERO_MEMORY As Long = &H8
Private Const HEAP_GENERATE_EXCEPTIONS As Long = &H4
Private Declare Function HeapAlloc Lib "kernel32" (ByVal hHeap As Long, ByVal dwFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function HeapFree Lib "kernel32" (ByVal hHeap As Long, ByVal dwFlags As Long, lpMem As Any) As Long
Private Declare Function GetProcessHeap Lib "kernel32" () As Long
Private Declare Function SetFocusAPI Lib "user32.dll" Alias "SetFocus" (ByVal hWnd As Long) As Long
Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Private Declare Function ReleaseCapture Lib "user32" () As Long

Private Type MyLVType
  hWnd As Long
  View As eListViewStyle
  ColumnCount  As Long
  Style As Long
End Type

Private Type LVITEM
  Mask       As Long
  iItem      As Long
  iSubItem   As Long
  state      As Long
  StateMask  As Long
  pszText    As String
  cchTextMax As Long
  iImage     As Long
  lParam     As Long
  iIndent    As Long
End Type

Dim LView As MyLVType
Dim WithEvents Free As cFree
Attribute Free.VB_VarHelpID = -1
Dim WithEvents Free2 As cFree
Attribute Free2.VB_VarHelpID = -1
Dim Rc As RECT
Dim g_b_Initialized As Boolean
Dim oKeys As Collection

Public Function pvButton(ByVal uMsg As Long) As Integer
    Select Case uMsg
        Case WM_LBUTTONDOWN, WM_LBUTTONUP
            pvButton = vbLeftButton
        Case WM_RBUTTONDOWN, WM_RBUTTONUP
            pvButton = vbRightButton
        Case WM_MBUTTONDOWN, WM_MBUTTONUP
            pvButton = vbMiddleButton
        Case WM_MOUSEMOVE
            Select Case True
                Case GetAsyncKeyState(vbKeyLButton) < 0
                    pvButton = vbLeftButton
                Case GetAsyncKeyState(vbKeyRButton) < 0
                    pvButton = vbRightButton
                Case GetAsyncKeyState(vbKeyMButton) < 0
                    pvButton = vbMiddleButton
            End Select
    End Select
End Function

Private Function Init(ByVal hWndParent As Long) As Boolean
  Dim dwStyle As Long
  dwStyle = WS_CHILD Or WS_TABSTOP Or LVS_LIST Or LVS_AUTOARRANGE Or LVS_SINGLESEL Or LVS_SHOWSELALWAYS 'Or LVS_SHAREIMAGELISTS
  LView.hWnd = CreateWindowEx(WS_EX_CLIENTEDGE, WC_LISTVIEW, vbNullString, dwStyle, 0, 0, ScaleWidth, ScaleHeight, hWndParent, 0&, App.hInstance, ByVal 0&)
  If LView.hWnd = 0 Then Exit Function
  Init = True
  Call ShowWindow(LView.hWnd, 1)
End Function

Public Sub Initialize()
  If g_b_Initialized Then Exit Sub
  g_b_Initialized = True
  Set Free = New cFree
  Set Free2 = New cFree
  'Call Init(UserControl.hWnd)
  Call Free.Hook(UserControl.hWnd)
  Call Free2.Hook(LView.hWnd)
  '***Call mIOleInPlaceActivate.InitIPAO(m_uIPAO, Me)
  Call mIOleInPlaceActivate.InitIPAO(Me)
End Sub

Property Get Checkboxes() As Boolean
  Checkboxes = (LView.Style And LVS_EX_CHECKBOXES) = LVS_EX_CHECKBOXES
End Property

Property Let Checkboxes(ByVal vNewValue As Boolean)
  Call pSetExtendedStyle(LVS_EX_CHECKBOXES, vNewValue)
End Property

Public Sub Sort(Optional ByVal ColumnIndex As Long = 0, _
         Optional ByVal SortAs As eSortAsConst = stText, _
         Optional ByVal SortOrder As eSortOrderConstants = [soAscending])
  m_lColumn = ColumnIndex
  lSortAs = SortAs
  m_PRECEDE = SortOrder
  m_FOLLOW = -SortOrder
  Call SendMessageLong(LView.hWnd, LVM_SORTITEMSEX, LView.hWnd, AddressOf hSortFunc)
End Sub

Property Get ListCount() As Long
  ListCount = SendMessage(LView.hWnd, LVM_GETITEMCOUNT, 0, ByVal 0&)
End Property

Property Get ColumnWidth(ByVal index As Long) As Long
  ColumnWidth = SendMessage(LView.hWnd, LVM_GETCOLUMNWIDTH, index, ByVal 0&)
End Property
Property Let ColumnWidth(ByVal index As Long, ByVal dwWidth As Long)
  Call SendMessage(LView.hWnd, LVM_SETCOLUMNWIDTH, index, ByVal dwWidth)
End Property

Public Function ItemAdd(ByVal Item As Integer, _
                        ByVal Text As String, _
                        ByVal Indent As Integer, _
                        ByVal Icon As Integer, _
                        Optional ByVal sKey As String) As Long
  Dim uLV As LVITEM
  Dim bKey() As Byte
  Dim dwLen As Long

  'VB
  Call oKeys.Add(sKey)
  uLV.lParam = oKeys.Count

  'API
  'bKey = sKey
  'dwLen = UBound(bKey) + 1
  'uLV.lParam = HeapAlloc(GetProcessHeap(), HEAP_GENERATE_EXCEPTIONS Or HEAP_ZERO_MEMORY, dwLen + 4)
  'Call CopyMemory(ByVal uLV.lParam, dwLen, 4)
  'Call CopyMemory(ByVal uLV.lParam + 4, bKey(0), dwLen)

  With uLV
    .iItem = Item
    .pszText = Text & vbNullChar
    .cchTextMax = Len(Text) + 1
    .iIndent = Indent
    .iImage = Icon
    .Mask = LVIF_TEXT Or LVIF_INDENT Or LVIF_IMAGE Or LVIF_PARAM
  End With

  ItemAdd = SendMessage(LView.hWnd, LVM_INSERTITEM, 0, uLV) ' (SendMessage(LView.hWnd, LVM_INSERTITEM, 0, uLV) > -1)

End Function

Public Property Get SubItemText(ByVal Item As Integer, ByVal SubItem As Integer) As String
  
  Dim uLVI   As LVITEM_lp
  Dim a(256) As Byte
  Dim lLen   As Long
    
    If (LView.hWnd) Then
        
        With uLVI
            .iSubItem = SubItem
            .pszText = VarPtr(a(0))
            .cchTextMax = UBound(a)
            .Mask = LVIF_TEXT
        End With
        lLen = SendMessage(LView.hWnd, LVM_GETITEMTEXT, Item, uLVI)
        
        SubItemText = VBA.Left$(StrConv(a(), vbUnicode), lLen)
    End If
End Property

Public Property Let SubItemText(ByVal Item As Integer, ByVal SubItem As Integer, ByVal Text As String)

  Dim uLVI As LVITEM

  If (LView.hWnd) Then
      With uLVI
          .iSubItem = SubItem
          .pszText = Text & vbNullChar
          .cchTextMax = Len(Text) + 1
      End With
      Call SendMessage(LView.hWnd, LVM_SETITEMTEXT, Item, uLVI)
  End If

End Property

Public Sub AutoSizeColumn(ByVal index As Long)
  
  If LView.hWnd Then
    Call SendMessage(LView.hWnd, LVM_SETCOLUMNWIDTH, index, LVSCW_AUTOSIZE_USEHEADER)
  End If
End Sub

Private Sub pSetExtendedStyle(ByVal iStyle As Long, ByVal bNew As Boolean)
  If bNew Then LView.Style = LView.Style Or iStyle Else LView.Style = LView.Style And Not iStyle
  If bNew Then
    SendMessage LView.hWnd, LVM_SETEXTENDEDSTYLE, 0, ByVal SendMessage(LView.hWnd, LVM_GETEXTENDEDSTYLE, 0, 0) Or iStyle
  Else
    SendMessage LView.hWnd, LVM_SETEXTENDEDSTYLE, 0, ByVal SendMessage(LView.hWnd, LVM_GETEXTENDEDSTYLE, 0, 0) And Not iStyle
  End If
End Sub

Public Property Let FullRowSelect(bol As Boolean)
  pSetExtendedStyle LVS_EX_FULLROWSELECT, bol
End Property
Public Property Get FullRowSelect() As Boolean
  FullRowSelect = LView.Style And LVS_EX_FULLROWSELECT
End Property

Public Property Let FlatScrollBar(bol As Boolean)
  pSetExtendedStyle LVS_EX_FLATSB, bol
End Property
Public Property Get FlatScrollBar() As Boolean
  FlatScrollBar = LView.Style And LVS_EX_FLATSB
End Property

Public Property Let GridLines(bol As Boolean)
  pSetExtendedStyle LVS_EX_GRIDLINES, bol
End Property
Public Property Get GridLines() As Boolean
  GridLines = LView.Style And LVS_EX_GRIDLINES
End Property

Public Property Get ColumnCount() As Long
  ColumnCount = LView.ColumnCount
End Property

Public Function ColumnAdd(ByVal Caption As String, ByVal Width As Long, Optional ByVal Align As AlignConsts = LVCFMT_LEFT) As Boolean

  Dim LVC As LV_COLUMN

  If LView.hWnd Then
    LVC.Mask = LVCF_FMT Or LVCF_TEXT Or LVCF_WIDTH Or LVCF_SUBITEM
    LVC.pszText = StrPtr(StrConv(Caption, vbFromUnicode))
    LVC.fmt = Align
    LVC.cx = Width
    LVC.iOrder = 0
    Call SendMessage(LView.hWnd, LVM_INSERTCOLUMN, LView.ColumnCount, LVC)
    LView.ColumnCount = LView.ColumnCount + 1
  End If

End Function

Public Property Set ImageList(ImageSize As ImageListSize, ImgList As cImgList)
  Call SendMessage(LView.hWnd, LVM_SETIMAGELIST, ImageSize, ByVal ImgList.hWnd)
End Property

Public Sub Move(dwLeft As Single, Optional dwTop As Single, Optional dwWidth As Single, Optional dwHeight As Single)
  Call MoveWindow(LView.hWnd, dwLeft, dwTop, dwWidth, dwHeight, 1)
End Sub

Public Property Let Visible(vis As Boolean)
  ShowWindow LView.hWnd, IIf(vis, 1, 0)
End Property

Public Property Get Visible() As Boolean
  Visible = IsWindowVisible(LView.hWnd)
End Property

Public Property Get View() As eListViewStyle
  View = LView.View
End Property

Sub Clear()
  Set oKeys = New Collection
  Call SendMessage(LView.hWnd, LVM_DELETEALLITEMS, 0, ByVal 0&)
End Sub

Public Property Let View(ByVal vNewValue As eListViewStyle)
  Dim iNot As Long
  iNot = (LVS_ICON Or LVS_SMALLICON Or LVS_REPORT Or LVS_LIST)
  SetWindowLong LView.hWnd, GWL_STYLE, (GetWindowLong(LView.hWnd, GWL_STYLE) And Not iNot) Or vNewValue
End Property

Private Sub Class_Initialize()
  'Call InitCommonControls
End Sub

Public Property Get Name() As String
  'Name = Me.Name
End Property

Public Property Get hWnd() As Long
  hWnd = LView.hWnd
End Property

Public Property Get Left() As Single
  GetWindowRect LView.hWnd, Rc
  Left = Rc.Left
End Property
Public Property Get Top() As Single
  GetWindowRect LView.hWnd, Rc
  Top = Rc.Top
End Property
Public Property Get Width() As Single
  GetWindowRect LView.hWnd, Rc
  Width = Rc.Right - Rc.Left
End Property
Public Property Get Height() As Single
  GetWindowRect LView.hWnd, Rc
  Height = Rc.Bottom - Rc.Top
End Property

Public Property Let Left(ByVal vNewValue As Single)
  MoveWindow LView.hWnd, vNewValue, Top, Width, Height, 1
End Property
Public Property Let Top(ByVal vNewValue As Single)
  MoveWindow LView.hWnd, Left, vNewValue, Width, Height, 1
End Property
Public Property Let Width(ByVal vNewValue As Single)
  MoveWindow LView.hWnd, Left, Top, vNewValue, Height, 1
End Property
Public Property Let Height(ByVal vNewValue As Single)
  MoveWindow LView.hWnd, Left, Top, Width, vNewValue, 1
End Property

Public Property Let AllowColumnReorder(bol As Boolean)
  Call pSetExtendedStyle(LVS_EX_HEADERDRAGDROP, bol)
End Property

Public Property Get AllowColumnReorder() As Boolean
  AllowColumnReorder = (LView.Style And LVS_EX_HEADERDRAGDROP)
End Property

Private Sub Free_Message(ByVal dwHwnd As Long, uMsg As Long, wParam As Long, lParam As Long)

    Dim i As Long, idx As Long
    Dim PrevProc As Long
    Dim hti As HDHITTESTINFO
    Dim uNMHeader As NMHDR
    Dim tNMListView As NMLISTVIEW
    Dim pt As POINTAPI

    If dwHwnd = UserControl.hWnd Then
  
        Select Case uMsg
        Case WM_MOUSEACTIVATE
          Call pvSetIPAO(Me)
        Case WM_SETFOCUS
          Call SetFocusAPI(LView.hWnd)
        Case WM_NOTIFY

            Call CopyMemory(uNMHeader, ByVal lParam, Len(uNMHeader))
            
            If (uNMHeader.hwndFrom = LView.hWnd) Then
                Select Case uNMHeader.code
                Case NM_CLICK, NM_RCLICK
                  Call GetCursorPos(pt)
                  Call ScreenToClient(LView.hWnd, pt)
                  Dim dwButton As Integer
                  Select Case True
                      Case GetAsyncKeyState(vbKeyLButton) > 0
                          dwButton = vbLeftButton
                      Case GetAsyncKeyState(vbKeyRButton) > 0
                          dwButton = vbRightButton
                      Case GetAsyncKeyState(vbKeyMButton) > 0
                          dwButton = vbMiddleButton
                  End Select
            
                  RaiseEvent MouseUp(dwButton, ShiftState, CSng(pt.x), CSng(pt.y))
                Case NM_SETFOCUS
                  Call pvSetIPAO(Me)
                Case LVN_ITEMCHANGED
                  Call CopyMemory(tNMListView, ByVal lParam, Len(tNMListView))
                  With tNMListView
                    If (.uOldState) Then
                      If ((.uNewState And LVIS_STATEIMAGEMASK) <> (.uOldState And LVIS_STATEIMAGEMASK)) Then
                        RaiseEvent ItemCheck(.iItem, GetItemKey(.lParam))
                      End If
                    Else
                      If .uNewState And LVIS_SELECTED Then
                        RaiseEvent ItemClick(.iItem, GetItemKey(.lParam))
                      End If
                    End If
                  End With
                End Select
            End If

        Case WM_MOUSEMOVE
          Call GetCursorPos(hti.pt)
          Call ScreenToClient(dwHwnd, hti.pt)
          Call SendMessage(dwHwnd, HDM_HITTEST, 0&, hti)

        Case Else
        End Select

    End If
  
End Sub

Private Function GetItemKey(ByVal lParam As Long) As String

  'VB
  GetItemKey = oKeys(lParam)

  'API
  'Dim bKey() As Byte
  'Dim dwLen As Long
  'Call CopyMemory(dwLen, ByVal lParam, 4)
  'ReDim bKey(dwLen - 1)
  'Call CopyMemory(bKey(0), ByVal lParam + 4, dwLen)
  'GetItemKey = bKey ' MsgBox(bKey, , dwLen)

End Function

Private Sub Free2_Message(ByVal dwHwnd As Long, uMsg As Long, wParam As Long, lParam As Long)
    Dim pt As POINTAPI
    If dwHwnd = LView.hWnd Then
        Select Case uMsg
        Case WM_LBUTTONUP, WM_RBUTTONUP, WM_MBUTTONUP
          Call GetCursorPos(pt)
          Call ScreenToClient(LView.hWnd, pt)
          RaiseEvent MouseUp(pvButton(uMsg), ShiftState, CSng(pt.x), CSng(pt.y))
        Case WM_LBUTTONDOWN, WM_RBUTTONDOWN, WM_MBUTTONDOWN
          Call GetCursorPos(pt)
          Call ScreenToClient(LView.hWnd, pt)
          RaiseEvent MouseDown(pvButton(uMsg), ShiftState, CSng(pt.x), CSng(pt.y))
        End Select
    End If
End Sub

Private Sub UserControl_Resize()
  Call Move(0, 0, ScaleWidth, ScaleHeight)
End Sub

Private Sub UserControl_Initialize()
  Set oKeys = New Collection
  UserControl.ScaleMode = vbPixels
  Call Init(UserControl.hWnd)
End Sub

'Public Property Get HeaderPosition(ByVal index As Long) As Long
'    Dim ColumnHeaderPosition() As Long
'    Dim nCount As Long
'    nCount = LView.ColumnCount
'    ReDim ColumnHeaderPosition(nCount)
'    Call SendMessage(hWnd, LVM_GETCOLUMNORDERARRAY, nCount, ColumnHeaderPosition(0))
'    HeaderPosition = ColumnHeaderPosition(index)
'End Property

Private Sub UserControl_GotFocus()
  '  :
  'Call mIOleInPlaceActivate.InitIPAO(m_uIPAO, Me)
  'Free.Hook(UserControl.hWnd)
  If (Me.hWnd) Then
    Call SetFocusAPI(Me.hWnd)
  End If
End Sub

Private Sub UserControl_Terminate()
  Dim i As Long
  Dim pitem As LVITEM_lp
  If LView.hWnd <> 0 Then
    '        HeapAlloc
    '    API =)   HeapAlloc()
    'For i = 0 To Me.ListCount - 1
    '  pitem.iItem = i
    '  pitem.Mask = LVIF_PARAM
    '  Call ListView_GetItem(pitem.iItem, pitem)
    '  If pitem.lParam <> 0 Then
    '    Call HeapFree(GetProcessHeap(), 0, pitem.lParam)
    '    pitem.lParam = 0
    '  End If
    'Next
  End If
  Call TerminateIPAO(Me)
End Sub

Private Function ListView_GetItem(ByVal index As Long, pitem As LVITEM_lp)
  Dim dwRet As Long
  dwRet = SendMessage(LView.hWnd, LVM_GETITEM, index, pitem)
End Function

Friend Function pvEdithWnd() As Long
    If (Me.hWnd) Then pvEdithWnd = SendMessageLong(Me.hWnd, LVM_GETEDITCONTROL, 0, 0)
End Function

'Friend Property Get uIPAO() As IPAOHookStructListView
'  uIPAO = m_uIPAO
'End Property

'Friend Function frTranslateAccel(pMsg As msg) As Boolean
'
'  Dim pOleObject As IOleObject
'  Dim pOleControlSite As IOleControlSite
'  Dim hEdit As Long
'
'  On Error Resume Next
'
'  Select Case pMsg.Message
'  Case WM_KEYDOWN, WM_KEYUP
'
'      Select Case pMsg.wParam
'        Case vbKeyTab
'          If (ShiftState() And vbCtrlMask) Then
'              Set pOleObject = Me
'              Set pOleControlSite = pOleObject.GetClientSite
'              If (Not pOleControlSite Is Nothing) Then
'                  Call pOleControlSite.TranslateAccelerator(VarPtr(pMsg), ShiftState() And vbShiftMask)
'              End If
'          End If
'          frTranslateAccel = False
'        Case vbKeyUp, vbKeyDown, vbKeyLeft, vbKeyRight, vbKeyHome, vbKeyEnd, vbKeyPageDown, vbKeyPageUp
'          hEdit = pvEdithWnd()
'          If (hEdit) Then
'              Call SendMessageLong(hEdit, pMsg.Message, pMsg.wParam, pMsg.lParam)
'          Else
'              Call SendMessageLong(Me.hWnd, pMsg.Message, pMsg.wParam, pMsg.lParam)
'          End If
'          frTranslateAccel = True
'      End Select
'  End Select
'
'  On Error GoTo 0
'
'End Function

Public Property Get ItemKey(ByVal index As Long) As Variant
  
  Dim pitem As LVITEM_lp

  If LView.hWnd = 0 Then Exit Property
  pitem.iItem = index
  pitem.Mask = LVIF_PARAM
  Call ListView_GetItem(index, pitem)

  If (pitem.lParam > 0) And (pitem.lParam < oKeys.Count) Then
    ItemKey = GetItemKey(pitem.lParam)
  End If

End Property

Public Property Let ItemKey(ByVal index As Long, ByVal vNewValue As Variant)

  Dim pitem As LVITEM_lp

  If LView.hWnd = 0 Then Exit Property
  pitem.iItem = index
  pitem.Mask = LVIF_PARAM
  Call ListView_GetItem(index, pitem)

  If (pitem.lParam > 0) And (pitem.lParam < oKeys.Count) Then
    Call oKeys.Remove(pitem.lParam)
    Call oKeys.Add(vNewValue, , pitem.lParam)
  End If

End Property

