VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsIpAddress"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Copyright by ALXR: Founder1e2[at]gmail[dot]com

Private Declare Function EnableWindow Lib "user32.dll" (ByVal hWnd As Long, ByVal bEnabled As Boolean) As Long
Private Declare Function IsWindowEnabled Lib "user32.dll" (ByVal hWnd As Long) As Long
Private Declare Function GetWindowLongA Lib "user32.dll" (ByVal hWnd As Long, ByVal dwValue As Long) As Long
Private Declare Function SendMessageA Lib "user32.dll" (ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Any) As Long
Private Declare Function SendMsg Lib "user32.dll" Alias "SendMessageA" (ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function CreateWindowExA Lib "user32" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Sub InitCommonControlsEx Lib "comctl32.dll" (ICC As ICC)
Private Declare Function CreateFontA Lib "gdi32" (ByVal h As Long, ByVal W As Long, ByVal E As Long, ByVal O As Long, ByVal W As Long, ByVal i As Long, ByVal u As Long, ByVal S As Long, ByVal C As Long, ByVal OP As Long, ByVal CP As Long, ByVal Q As Long, ByVal PAF As Long, ByVal F As String) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long
Private Declare Function inet_addr Lib "wsock32.dll" (ByVal lp As String) As Long
Private Declare Function ReverseIP Lib "wsock32.dll" Alias "htonl" (ByVal hostlong As Long) As Long
Private Declare Function CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (CopyTO As Any, CopyFROM As Any, ByVal uBytes As Long) As Long
Private Declare Function IsBadReadPtr Lib "kernel32.dll" (ByVal lp As Any, ByVal uBytes As Long) As Long

Private Const IPM_CLEARADDRESS As Long = 1124
Private Const IPM_SETADDRESS As Long = 1125
Private Const IPM_GETADDRESS As Long = 1126
Private Const IPM_SETRANGE As Long = 1127
Private Const IPM_SETFOCUS As Long = 1128
Private Const IPM_ISBLANK As Long = 1129

Private Type ICC
    dwLength As Long
    dwICC As Long
End Type

Private Type FIELD
    hWnd As Long
    lpfnWndProc As Long
    byLow As Byte
    byHigh As Byte
    iUnknown As Integer
End Type

Dim hIp As Long

Private Sub Class_Initialize()
Dim lpicc As ICC
lpicc.dwLength = Len(lpicc)
lpicc.dwICC = &H3FFF&
Call InitCommonControlsEx(lpicc)
End Sub

Private Sub Class_Terminate()
DestroyWindow hIp
End Sub

Private Function LIP2IP(ByVal LIP As Long) As String
Dim b(1 To 4) As Byte
CopyMemory b(1), LIP, 4
LIP2IP = CStr(b(1)) & "." & CStr(b(2)) & "." & CStr(b(3)) & "." & CStr(b(4))
End Function

Private Function GetField(ByVal i As Integer) As FIELD
' Is this code realy working with all versions of comctl32.dll ?
Const IPADDR_SIZE As Long = 24
Dim h As Long
h = GetWindowLongA(hIp, -21)
If IsBadReadPtr(h, IPADDR_SIZE + 4 * Len(GetField)) = 0 And i >= 1 And i <= 4 Then
    CopyMemory GetField, ByVal (h + IPADDR_SIZE + Len(GetField) * (i - 1)), Len(GetField)
End If
End Function

Sub Create(fParent As Object, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, Optional ByVal dwStyle As Long, Optional ByVal dwExStyle As Long, Optional ByVal bVisible As Boolean = True)
Dim hParent As Long
If TypeOf fParent Is Form Or TypeOf fParent Is PictureBox Then
    x = fParent.ScaleX(x, fParent.ScaleMode, vbPixels): cx = fParent.ScaleX(cx, fParent.ScaleMode, vbPixels)
    y = fParent.ScaleY(y, fParent.ScaleMode, vbPixels): cy = fParent.ScaleY(cy, fParent.ScaleMode, vbPixels)
ElseIf TypeOf fParent Is Frame Then
    x = x / Screen.TwipsPerPixelX: y = y / Screen.TwipsPerPixelY
    cx = cx / Screen.TwipsPerPixelX: cy = cy / Screen.TwipsPerPixelY
Else
    Exit Sub
End If
dwStyle = dwStyle Or &H40000000
If bVisible Then dwStyle = dwStyle Or &H10000000
hParent = fParent.hWnd
hIp = CreateWindowExA(dwExStyle, "SysIpAddress32", "", dwStyle, x, y, cx, cy, hParent, 0, App.hInstance, ByVal 0&)
If hIp <> 0 Then
    Dim hFont As Long
    hFont = CreateFontA(-fParent.FontSize * GetDeviceCaps(fParent.hDC, 90) \ 72, 0, 0, 0, IIf(70, fParent.FontBold, 0), fParent.FontItalic, fParent.FontUnderline, fParent.FontStrikethru, 1, 0, 0, 0, 0, fParent.FontName)
    SendMessageA hIp, 48, hFont, 1&
    ' We don't needing to destroy font because it will be destroyed with this control.
End If
End Sub

Sub CreateOnShape(fParent As Object, fPrototype As Shape, Optional ByVal dwStyle As Long, Optional ByVal dwExStyle As Long, Optional ByVal bVisible As Boolean = True)
Call Create(fParent, fPrototype.Left, fPrototype.Top, fPrototype.Width, fPrototype.Height, dwStyle, dwExStyle, bVisible)
fPrototype.Visible = (hIp = 0)
End Sub

Property Get ip() As String
ip = LIP2IP(DwordIP)
End Property

Property Get DwordIP() As Long
SendMessageA hIp, IPM_GETADDRESS, 0, VarPtr(DwordIP)
DwordIP = ReverseIP(DwordIP)
End Property

Property Let ip(ByVal lp As String)
DwordIP = ReverseIP(inet_addr(lp))
End Property

Property Let DwordIP(ByVal dw As Long)
SendMessageA hIp, IPM_SETADDRESS, 0, dw
End Property

Function IsBlank() As Boolean
IsBlank = SendMessageA(hIp, IPM_ISBLANK, 0, 0&)
End Function

Property Get Enable(ByVal i As Long) As Boolean
Enable = IsWindowEnabled(GetField(i).hWnd)
End Property

Property Let Enable(ByVal i As Long, ByVal bEnabled As Boolean)
EnableWindow GetField(i).hWnd, bEnabled
End Property

