Attribute VB_Name = "mListView"
Option Explicit

'Written by SCINER: lenar2003@mail.ru

Public lSortAs As Long
Public m_lColumn As Long
Public m_PRECEDE As Long
Public m_FOLLOW As Long

Public Const LVM_FIRST           As Long = &H1000
Public Const LVIF_TEXT           As Long = &H1
Public Const LVIF_IMAGE          As Long = &H2
Public Const LVIF_PARAM          As Long = &H4
Public Const LVIF_STATE          As Long = &H8
Public Const LVIF_INDENT         As Long = &H10
Public Const LVIF_GROUPID        As Long = &H100
Public Const LVIF_COLUMNS        As Long = &H200
Public Const LVM_GETITEMTEXT     As Long = (LVM_FIRST + 45)

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Public Type LVITEM_lp
  Mask       As Long
  iItem      As Long
  iSubItem   As Long
  state      As Long
  StateMask  As Long
  pszText    As Long
  cchTextMax As Long
  iImage     As Long
  lParam     As Long
  iIndent    As Long
End Type

Private m_uLVI As LVITEM_lp

Function hSortFunc(ByVal lParam1 As Long, _
                   ByVal lParam2 As Long, _
                   ByVal hWnd As Long) As Long

  Select Case lSortAs
  Case stText: hSortFunc = IIf(pvGetItemText(hWnd, lParam1) > pvGetItemText(hWnd, lParam2), m_PRECEDE, m_FOLLOW)
  Case stIndex: hSortFunc = IIf(lParam1 > lParam2, m_PRECEDE, m_FOLLOW)
  Case stDate: hSortFunc = IIf(CDate(pvGetItemText(hWnd, lParam1)) > CDate(pvGetItemText(hWnd, lParam2)), m_PRECEDE, m_FOLLOW)
  Case stNumber: hSortFunc = IIf(Val(pvGetItemText(hWnd, lParam1)) > Val(pvGetItemText(hWnd, lParam2)), m_PRECEDE, m_FOLLOW)
  End Select

End Function

Private Function pvGetItemText(ByVal hWnd As Long, ByVal lParam As Long) As String
  Dim lIdx   As Long
  Dim a(261) As Byte
  Dim lLen   As Long
  With m_uLVI
      .Mask = LVIF_TEXT
      .pszText = VarPtr(a(0))
      .cchTextMax = UBound(a)
      .iSubItem = m_lColumn
  End With
  lLen = SendMessage(hWnd, LVM_GETITEMTEXT, lParam, m_uLVI)
  pvGetItemText = VBA.Left$(StrConv(a(), vbUnicode), lLen)
End Function
